var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var F10120;
(function (F10120) {
    var FDocument = (function (_super) {
        __extends(FDocument, _super);
        function FDocument(id, version, oldVersion) {
            var _this = _super.call(this, id, version, oldVersion) || this;
            _this._p2Sheet = null;
            _this._p3Sheet = null;
            _this._analyticsDataTable = null;
            _this._analyticSheet = null;
            _this._p5RefObjTable = null;
            _this._p5RefOkpdTable = null;
            _this._p5RefKosguTable = null;
            _this._p5RefObjDescTable = null;
            _this._p5RefObjDescNpaTable = null;
            _this._p5Sp1Sheet = null;
            _this._tableRules = new F10120.TableRules(_this);
            _this._interfaceRules = new F10120.InterfaceRules(_this);
            _this._updateRules = new F10120.UpdateRules(_this);
            _this._exportRules = new F10120.ExportRules(_this);
            _this._tableP1 = new F10120.ObasTableP1Total("F10_100_R1_SumValues", _this);
            _this._tableP2SbP1 = new F10120.ObasTableActionData("F10_100_r2_1", _this, _this.TableP1, F10120.StrKeysP1Total.P2);
            _this._tableP3SbP1 = new F10120.UsdActionDataObasTable("F10_100_r3_1", _this, _this.TableP1, F10120.StrKeysP1Total.P3);
            return _this;
        }
        Object.defineProperty(FDocument.prototype, "TotalTable", {
            get: function () {
                return this.TableP1;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "P3Sheet", {
            get: function () {
                if (this._p3Sheet == null) {
                    this._p3Sheet = new F10120.P3Sheet("SHT_F10_100_r3_1", this);
                }
                return this._p3Sheet;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "P2Sheet", {
            get: function () {
                if (this._p2Sheet == null) {
                    this._p2Sheet = new F10120.P2Sheet("SHT_F10_100_r2_1", this);
                }
                return this._p2Sheet;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "TableRules", {
            get: function () {
                return this._tableRules;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "InterfaceRules", {
            get: function () {
                return this._interfaceRules;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "UpdateRules", {
            get: function () {
                return this._updateRules;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "ExportRules", {
            get: function () {
                return this._exportRules;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "TableP1", {
            get: function () {
                return this._tableP1;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "TableP2SbP1", {
            get: function () {
                return this._tableP2SbP1;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "TableP3SbP1", {
            get: function () {
                return this._tableP3SbP1;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "AnalyticsDataTable", {
            get: function () {
                if (this._analyticsDataTable == null) {
                    this._analyticsDataTable = new AnalyticsKosgu.AnalyticsDataTable("AnalyticsData", this);
                }
                return this._analyticsDataTable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "AnalyticSheet", {
            get: function () {
                if (this._analyticSheet == null) {
                    this._analyticSheet = new AnalyticsKosgu.AnalyticsSheet("SHT_RA", this);
                }
                return this._analyticSheet;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "PurchaseObjectsSprTable", {
            get: function () {
                if (this._purchaseObjectsSprTable == null) {
                    this._purchaseObjectsSprTable = new F01XXXBase.PurchaseObjectsSprTable();
                }
                return this._purchaseObjectsSprTable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "P5RefObjTable", {
            get: function () {
                if (this._p5RefObjTable == null) {
                    this._p5RefObjTable = new F01XXXBase.PartObjectDataTable("F10_120_R5_Ref_Object", this, this.P5RefObjDescTable);
                }
                return this._p5RefObjTable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "P5RefOkpdTable", {
            get: function () {
                if (this._p5RefOkpdTable == null) {
                    this._p5RefOkpdTable = new F01XXXBase.PartOkpdTable("F10_120_R5_Ref_Okpd", this, this.P5RefObjTable);
                }
                return this._p5RefOkpdTable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "P5RefKosguTable", {
            get: function () {
                if (this._p5RefKosguTable == null) {
                    this._p5RefKosguTable = new F01XXXBase.PartKosguTable("F10_120_R5_Ref_Kosgu", this, this.P5RefOkpdTable);
                }
                return this._p5RefKosguTable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "P5RefObjDescTable", {
            get: function () {
                if (this._p5RefObjDescTable == null) {
                    this._p5RefObjDescTable = new F01XXXBase.ObjectDescTable("F10_120_R5_Ref_ObjectDesc", this);
                }
                return this._p5RefObjDescTable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "P5RefObjDescNpaTable", {
            get: function () {
                if (this._p5RefObjDescNpaTable == null) {
                    this._p5RefObjDescNpaTable = new F01XXXBase.ObjectDescNpaTable("F10_120_R5_Ref_Npa", this, this.P5RefObjDescTable);
                }
                return this._p5RefObjDescNpaTable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FDocument.prototype, "P5Sp1Sheet", {
            get: function () {
                if (this._p5Sp1Sheet == null) {
                    this._p5Sp1Sheet = new F01XXXBase.PurchaseObjectHierarchySheet(this);
                }
                return this._p5Sp1Sheet;
            },
            enumerable: true,
            configurable: true
        });
        return FDocument;
    }(BaseDocumentObject));
    F10120.FDocument = FDocument;
})(F10120 || (F10120 = {}));
